﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Xml;
using System.Xml.Linq;
using System.ComponentModel;

namespace XamDataGridXMLBinding
{
	public class DataModel : INotifyPropertyChanged
	{
		private IEnumerable tradeProperties;

		public IEnumerable TradeProperties
		{
			get { return tradeProperties; }
			set 
			{ 
				tradeProperties = value;

				OnPropertyChanged(new PropertyChangedEventArgs("TradeProperties"));
			}
		}

		protected void OnPropertyChanged(PropertyChangedEventArgs e)
		{
			if (PropertyChanged != null)
			{
				PropertyChanged(this, e);
			}
		}

		#region INotifyPropertyChanged Members

		public event PropertyChangedEventHandler PropertyChanged;

		#endregion
	}

	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		private readonly DataModel m_dataModel;

		public Window1()
		{
			InitializeComponent();

			m_dataModel = new DataModel();
			this.DataContext = m_dataModel;
		}


		private XElement m_tradeDefinition;

		private void ButtonBase_OnClick(object sender, RoutedEventArgs e)
		{
			m_tradeDefinition = XElement.Load(@"..\..\swap_sample.xml");

			Func<string, string, object> convertFunc = (x, y) => {
			                   		Type type = Type.GetType(x);
			                   		object value = Convert.ChangeType(y, type);
			                   		return value; };

			var props = from Property in m_tradeDefinition.Elements() select new { Key = Property.Name.ToString(), Value = convertFunc(Property.Attribute("Type").Value, Property.Value) };

			 m_dataModel.TradeProperties = props;

			//m_tradeDetailsGrid.DataSource = model.TradeProperties;
		}

		private void DumpXml_OnClick(object sender, RoutedEventArgs e)
		{
			if (m_tradeDefinition != null)
			{
				Console.Write(m_tradeDefinition.Value);
			}
		}
	}
}



